% makebisectbmps.m makes individual frames for AOSLO bisection psyphi
% mar 2007 created to do bisection with WAIL routine
% image dimensions fixed for use with Rossi AOM controller

imdim = [512 512];

spotcolor = 0; backcolor = 255;
spotsize = 16;
blankframe = uint8(backcolor + zeros(imdim(1),imdim(2),3));
[fname pname] = uiputfile('frame2.bmp','Where to save these frames?');
cd(pname);
% imwrite(blankframe,'frame2.bmp');
stimradius_pixels = 33% 33 is 1/8 degree for 2 deg field, 1 pix = 120 / 528 = .23 arc min
framexcenter = imdim(2) / 2;
frameycenter = imdim(1) / 2;
spotxcenterlocs = framexcenter + [-16:4:16]; % one arcmin steps, 9 stimuli
temp = [0:spotsize - 1] - (spotsize / 2);

spotrows = frameycenter + temp;

for spotdx = 1:9
    thisframe = blankframe;
    spotcols = framexcenter - stimradius_pixels + temp;
    thisframe(spotrows,spotcols,:) = spotcolor;
    spotcols = framexcenter + stimradius_pixels + temp;
    thisframe(spotrows,spotcols,:) = spotcolor;
    spotcols = spotxcenterlocs(spotdx) + temp;
    thisframe(spotrows,spotcols,:) = spotcolor;
    thisname = ['frame' num2str(spotdx+1) '.bmp'];
	figure(1);image(thisframe);title(thisname);truesize;drawnow;
	imwrite(thisframe, [pname thisname]);
end

