% makefixationbmps.m makes individual frames for AOSLO saccade psyphi
% feb-mar 2004 sbs peace*love*trees
% june 2004 adapted from makemotionbmps3.m
% image dimensions fixed for use with SidPoonja AOM controller

imdim = [512 512];

spotcolor = 0; backcolor = 255;
spotsize = 16;
blankframe = uint8(backcolor + zeros(imdim(1),imdim(2),3));
[fname pname] = uiputfile('frame2.bmp','Where to save these frames?');
cd(pname);
% imwrite(blankframe,'frame2.bmp');

framexcenter = imdim(2) / 2;
frameycenter = imdim(1) / 2;

spotxcenterlocs = [framexcenter - (spotsize * 2),framexcenter - (spotsize * 2),framexcenter + (spotsize * 2),framexcenter + (spotsize * 2)];
spotycenterlocs = [frameycenter - (spotsize * 2),frameycenter + (spotsize * 2),frameycenter - (spotsize * 2),frameycenter + (spotsize * 2)];
temp = [0:spotsize - 1] - (spotsize / 2);


for spotdx = 1:4
    spotcols = spotxcenterlocs(spotdx) + temp;
    spotrows = spotycenterlocs(spotdx) + temp;
    thisframe = blankframe;
    thisframe(spotrows,spotcols,:) = spotcolor;
    thisname = ['frame' num2str(spotdx) '.bmp'];
	figure(1);image(thisframe);title(thisname);truesize;drawnow;
	imwrite(thisframe, [pname thisname]);
    pause(0.25)
end

