function BasicExp

global SYSPARAMS StimParams VideoParams; %#ok<NUSED>

if exist('handles','var') == 0;
    handles = guihandles;
else
    %donothing
end

startup;

%get experiment config data stored in appdata for 'hAomControl'
hAomControl = getappdata(0,'hAomControl');
uiwait(ColorNamingBasicConfig);
CFG = getappdata(hAomControl, 'CFG');
psyfname = [];

if isstruct(getappdata(getappdata(0,'hAomControl'),'CFG')) == 1;
    CFG = getappdata(getappdata(0,'hAomControl'),'CFG');
    if CFG.ok == 1
        StimParams.stimpath = CFG.stimpath;
        VideoParams.vidprefix = CFG.vidprefix;
        set(handles.aom1_state, 'String', 'Configuring Experiment...');
        if SYSPARAMS.realsystem == 1 && SYSPARAMS.board == 'm'
            set(handles.aom1_state, 'String', 'Off - Press Start Button To Begin Experiment');
        else
            set(handles.aom1_state, 'String', 'On - Press Start Button To Begin Experiment');
        end
        if CFG.record == 1;
            VideoParams.videodur = CFG.vdur;
        end
        psyfname = set_VideoParams_PsyfileName();  
        hAomControl = getappdata(0,'hAomControl');
        Parse_Load_Buffers(1);
        set(handles.image_radio1, 'Enable', 'off');
        set(handles.seq_radio1, 'Enable', 'off');
        set(handles.im_popup1, 'Enable', 'off');
        set(handles.display_button, 'String', 'Running Exp...');
        set(handles.display_button, 'Enable', 'off');
        set(handles.aom1_state, 'String', 'On - Experiment Mode - Running Experiment');
    else
        return;
    end
end

SLR = 0;
if SLR ~= 0
    netcomm('write',SYSPARAMS.netcommobj,int8('RunSLR#'));
    pause(1);
%     netcomm('write',SYSPARAMS.netcommobj,int8('Fix#'));
%     command = ['Locate#' num2str(20) '#' num2str(20) '#']; %#ok<NASGU>
%     netcomm('write',SYSPARAMS.netcommobj,int8(command));
end




%setup the keyboard constants and response mappings from config
kb_AbortConst = 'escape'; 
kb_BadConst = 'uparrow';
kb_StimConst = 'space';

kb_ans1 = CFG.ans1;  kb_ans1_label = CFG.ans1_label;
kb_ans2 = CFG.ans2;  kb_ans2_label = CFG.ans2_label;
kb_ans3 = CFG.ans3;  kb_ans3_label = CFG.ans3_label;
kb_ans4 = CFG.ans4;  kb_ans4_label = CFG.ans4_label;
kb_ans5 = CFG.ans5;  kb_ans5_label = CFG.ans5_label; 
kb_ans6 = CFG.ans6;  kb_ans6_label = CFG.ans6_label;
kb_ans7 = CFG.ans7;  kb_ans7_label = CFG.ans7_label;
kb_ans8 = CFG.ans8;  kb_ans8_label = CFG.ans8_label;




stimsize = CFG.stimsize;
stimshape = CFG.stimshape;
ntrials   = CFG.ntrials;

dirname = StimParams.stimpath;
fprefix = StimParams.fprefix;

%grid locations_16Jan2013x150142.mat
%manual locations_16Jan2013x150207.mat
filename_locs = ['./data_color_Naming/' 'locations_16Jan2013x155115' '.mat'];
load(filename_locs);

num_locations = size(locations,1);
sequence = reshape(ones(ntrials,1)*(1:num_locations),1,num_locations*ntrials);
randids = randperm(numel(sequence));
sequence_rand = sequence(randids(1:length(sequence)));

% offset_matrix = ones(num_locations,2);  %col 1: xoffset, col2 : y offset
offset_matrix = locations;
% offset_matrix(1,1:2) = [0 -32];
% offset_matrix(2,1:2) = [0 -16];
% offset_matrix(3,1:2) = [0 16];
respnse_matrix = {};
response_matrix.trials = zeros(ntrials*num_locations,1);
response_matrix.locations = zeros(length(sequence_rand),1);
response_matrix.answer = zeros(ntrials*num_locations,1);
response_matrix.offsets = zeros(length(sequence_rand),2);
response_matrix.uniqueoffsets = locations;



%set up the movie parameters
Mov.dir = dirname;
Mov.suppress = 0;
Mov.pfx = fprefix;

experiment = 'Color Naming Basic';
subject = ['Observer: ' CFG.initials];
pupil = ['Pupil Size (mm): ' CFG.psize];
field = ['Field Size (deg): ' num2str(CFG.fsize)];
presentdur = ['Presentation Duration (ms): ' num2str(CFG.pdur)];
iti = ['Intertrial Interval (ms): ' num2str(CFG.tdur)];
videoprefix = ['Video Prefix: ' CFG.vpfx];
videofolder = ['Video Folder: ' VideoParams.videofolder];
videodur = ['Video Duration: ' num2str(CFG.vdur)];
num_trials = ['Number of Trials: ' num2str(CFG.ntrials)];

psyfid = fopen(psyfname,'a');
psyfid = fopen(psyfname,'a');
fprintf(psyfid,'%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n%s\r\n', psyfname, experiment, subject, pupil,field, presentdur, iti, videoprefix, videodur);

exp_parameters = {};
exp_parameters.experiment = experiment; 
exp_parameters.subject  = subject;
exp_parameters.pupil = pupil;
exp_parameters.field = field;
exp_parameters.presentdur = presentdur;
exp_parameters.iti = iti;
exp_parameters.videoprefix = videoprefix;
exp_parameters.videodur = videodur;
exp_parameters.stimsize = stimsize;
exp_parameters.stimsize = stimsize;
exp_parameters.ntrials = ntrials;
exp_parameters.num_locations = num_locations;

clear experiment subject pupil field presentdur iti videoprefix videofolder videodur num_trials


 fprintf(psyfid,'%s\r\nVideoFolder: %s\r\n', num2str(stimsize), VideoParams.videofolder);

fprintf(psyfid, '%s\t %s\t %s\r\n', 'Trial#', 'Resp.', 'Test Int');

SYSPARAMS.aoms_state(2)=1; % SWITCH RED ON
SYSPARAMS.aoms_state(3)=1; % SWITCH GREEN ON


startframe = 10;
fps = 30;
presentdur = CFG.presentdur/1000;
stimdur = round(fps*presentdur); %how long is the presentation
numframes = fps*CFG.videodur;

framenum = 2; %the index of your bitmap
framenum2 = 3;
framenum3 = 4;

aom1seq = [zeros(1,startframe-1) ones(1,stimdur).*framenum zeros(1,30-startframe+1-stimdur)];


aom1pow = ones(size(aom1seq));
aom1pow(:) = 1;

aom1offx = zeros(length(aom1seq));
aom1offy = zeros(length(aom1seq));
aom1offx(:) = 100;
aom1offy(:) = 100;

aom1offx_mat = zeros(length(aom1seq),length(aom1seq),num_locations);
aom1offy_mat = zeros(length(aom1seq),length(aom1seq),num_locations);

for ii = 1:num_locations
aom1offx_mat(:,:,ii) = offset_matrix (ii,1);
aom1offy_mat(:,:,ii) = offset_matrix (ii,2);
end

%AOM0 (IR) parameters
% aom0seq = ones(size(aom1seq));
% aom0seq = zeros(size(aom1seq));
% aom0seq = [zeros(1,cueframe-1) ones(1,stimdur).*framenum3 zeros(1,30-startframe+1-stimdur)];
aom0seq = [zeros(1,startframe-1) ones(1,stimdur).*framenum2 zeros(1,30-startframe+1-stimdur)];
aom2seq = [zeros(1,startframe-1) ones(1,stimdur).*framenum2 zeros(1,30-startframe+1-stimdur)];

aom0locx = zeros(size(aom1seq));
aom0locy = zeros(size(aom1seq));
aom0pow = ones(size(aom1seq));
aom0pow(:) = 1;


aom2pow = ones(size(aom1seq));
aom2pow(:) = 0.250;
aom2locx = zeros(size(aom1seq));
aom2locy = zeros(size(aom1seq));
aom2offx = zeros(size(aom1seq));
aom2offx(:) = 100;
aom2offy = zeros(size(aom1seq));
aom2offy(:) = 100;




gainseq = CFG.gain*ones(size(aom1seq));
angleseq = zeros(size(aom1seq));
stimbeep = zeros(size(aom1seq));
stimbeep(startframe+stimdur-1) = 1;
%stimbeep = [zeros(1,startframe+stimdur-1) 1 zeros(1,30-startframe-stimdur+2)];
%Set up movie parameters
Mov.duration = size(aom1seq,2);

Mov.aom0seq = aom0seq;
Mov.aom1seq = aom1seq;
Mov.aom0pow = aom0pow;

Mov.aom1pow = aom1pow;
Mov.aom0locx = aom0locx;
Mov.aom0locy = aom0locy;
Mov.aom1offx = aom1offx;
Mov.aom1offy = aom1offy;

Mov.aom2seq = aom2seq;
Mov.aom2pow = aom2pow;
Mov.aom2locx = aom2locx;
Mov.aom2locy = aom2locy;
Mov.aom2offx = aom2offx;
Mov.aom2offy = aom2offy;

Mov.gainseq = gainseq;
Mov.angleseq = angleseq;
Mov.stimbeep = stimbeep;
Mov.frm = 1;
Mov.seq = '';


%set initial while loop conditions
runExperiment = 1;
trial = 1;
PresentStimulus = 1;
GetResponse = 0;
set(handles.aom_main_figure, 'KeyPressFcn','uiresume');
good_check = 1;

trialIntensity = 1; % always 100% for this experiment

while(runExperiment ==1)
        uiwait;
        resp = get(handles.aom_main_figure,'CurrentKey');
    
     if strcmp(resp,kb_AbortConst);
            runExperiment = 0;
            uiresume;
            TerminateExp;
            
            message = ['Off - Experiment Aborted - Trial ' num2str(trial) ' of ' num2str(CFG.ntrials)];
            set(handles.aom1_state, 'String',message);
            
    elseif strcmp(resp,kb_StimConst)    % check if present stimulus button was pressed
            if PresentStimulus == 1
                
            createStimulus(trialIntensity, stimsize, stimshape)
            
                if SYSPARAMS.realsystem == 1
                    StimParams.stimpath = dirname;
                    StimParams.fprefix = fprefix;
                    StimParams.sframe = 2;
                    StimParams.eframe = 4;
                    StimParams.fext = 'bmp';
                    Parse_Load_Buffers(0);
                end                    
               
                laser_sel = 0;
                if SYSPARAMS.realsystem == 1 && SYSPARAMS.board == 'm'
                    bitnumber = round(8191*(2*trialIntensity-1));
                else
                    bitnumber = round(trialIntensity*1000);
                end
                
                
                Mov.duration = CFG.videodur*fps;
                Mov.frm = 1;
                Mov.aom1pow(:) = 0.5; Mov.aom0pow(:) = 1;
                Mov.aom1offx = aom1offx_mat(:,:,sequence_rand(trial));
                Mov.aom1offy = aom1offy_mat(:,:,sequence_rand(trial));
                    
                message = ['Running Experiment - Trial ' num2str(trial) ' of ' num2str(ntrials*num_locations)];
                Mov.msg = message;
                Mov.seq = '';
                setappdata(hAomControl, 'Mov',Mov);
                
                VideoParams.vidname = [CFG.vidprefix '_' sprintf('%03d',trial)];
              %   command = ['UpdatePower#' num2str(laser_sel) '#' num2str(bitnumber) '#'];            %#ok<NASGU>
                   
                PlayMovie;
                PresentStimulus = 0;
                GetResponse = 1;
            end       
            
    elseif(GetResponse == 1)
        if strcmp(resp,kb_ans1)
            response = 1;
            message1 = [Mov.msg ' Color: ' kb_ans1_label];
            GetResponse = 0;
            good_trial  = 1;
            
        elseif strcmp(resp,kb_ans2)
            response = 2;
            message1 = [Mov.msg ' Color: ' kb_ans2_label];
            GetResponse = 0;
            good_trial  = 1; 
            
        elseif strcmp(resp,kb_ans3)
            response = 3;
            message1 = [Mov.msg ' Color: ' kb_ans3_label];
            GetResponse = 0;
            good_trial  = 1;
            
        elseif strcmp(resp,kb_ans4)
            response = 4;
            message1 = [Mov.msg ' Color: ' kb_ans4_label];
            GetResponse = 0;
            good_trial  = 1;
            
        elseif strcmp(resp,kb_ans5)
            response = 5;
            message1 = [Mov.msg ' Color: ' kb_ans5_label];
            GetResponse = 0;
            good_trial = 1;
            
        elseif strcmp(resp,kb_ans6)
            response = 6;
            message1 = [Mov.msg ' Color: ' kb_ans6_label];
            GetResponse = 0;
            good_trial = 1;
            
        elseif strcmp(resp,kb_ans7)
            response = 7;
            message1 = [Mov.msg ' Color: ' kb_ans7_label];
            GetResponse = 0;
            good_trial = 1;
            
        elseif strcmp(resp,kb_ans8)
            response = 8;
            message1 = [Mov.msg ' Color: ' kb_ans8_label];
            GetResponse = 0;
            good_trial = 1;
                
        
        elseif strcmp(resp,kb_BadConst)
            message1 = [Mov.msg ' Repeat trial'];   
            GetResponse = 0;
            good_trial = 0;
        
        end
        
        if GetResponse == 0
            
            if good_trial 
            set(handles.aom1_state, 'String',message1);
            %write response to psyfile
            psyfid = fopen(psyfname,'a');
%             fprintf(psyfid,'%s %d %4.4f %4.4f %4.4f %4.4g\r\n',VideoParams.vidname,response,questIntensity,trialIntensity,QuestMean(q),QuestSd(q));
            fclose(psyfid);
            
            response_matrix.trials (trial) = trial;
            response_matrix.locations (trial) = sequence_rand(trial);
            response_matrix.answer(trial) = response;
            response_matrix.offsets(trial,:) = [offset_matrix(sequence_rand(trial),1) offset_matrix(sequence_rand(trial),2)];
            
            
            %update trial counter
            trial = trial + 1;
                if(trial > (ntrials*num_locations))
                    runExperiment = 0;
                    set(handles.aom_main_figure, 'keypressfcn','');
                    TerminateExp;
                    message = ['Off - Experiment Complete' ];
                    set(handles.aom1_state, 'String',message);
    % %                 figure;
    % %                 plot(theThreshold);
    % %                 xlabel('Trial number');
    % %                 ylabel('Min Vis Spot Intensity');
    % %                 title('Threshold estimate vs. Trial Number');
                else %continue experiment
                end
            end
            PresentStimulus = 1;
        end
    end
end


AllData = catstruct(exp_parameters, response_matrix)




figure; hist(AllData.answer);    
xlim([1 8]);set(gca,'xtick',[1 2 3 4 5 6 7 8]);




% figure;hist(AllData.answer(AllData.locations==1));
% figure;hist(AllData.answer(AllData.locations==2));
% figure;hist(AllData.answer(AllData.locations==3));

filename = ['data_color_naming_',strrep(strrep(strrep(datestr(now),'-',''),' ','x'),':',''),'.mat'];

if isdir([pwd,'\Data_Color_Naming']) == 0;
    mkdir(pwd,'Data_Color_Naming');
    cd([pwd,'\Data_Color_Naming']);
else
    cd([pwd,'\Data_Color_Naming']);
end

currentdir = cd;
cd(VideoParams.videofolder)
save(filename, 'AllData');
cd(currentdir);cd ..;

 
% clear CFG GetResponse PresentStimulus kb_AbortConst kb_UpArrow kb_RightArrow kb_DownArrow kb_LeftArrow kb_StimConst mapping message message1 movie_seq psyfid psyfname resp response runExperiment seqfname trial;

function createStimulus(trialIntensity, stimsize, stimshape)
% global offset

    
    
    
    if strcmp(stimshape, 'square')
        stim_im = zeros(stimsize+2, stimsize+2);
        stim_im(1:end-1,1:end-1) = 1;
        
    elseif strcmp(stimshape, 'circle')
       
        xp =  -fix(stimsize/2)  : fix(stimsize/2)-1;
        [x y] = meshgrid(xp);
        stim_im = (x.^2 + y.^2) <= (round(stimsize/2)).^2; 
    end
    
     stim_im = stim_im.*trialIntensity;
     

%Make cross     
ir_im = ones(21, 21);
ir_im(:,9:13)=0;
ir_im(9:13,:)=0;

% figure, imshow(stim_im)

if isdir([pwd,'\tempStimulus']) == 0;
    mkdir(pwd,'tempStimulus');
    cd([pwd,'\tempStimulus']);
    
%     blank_im = zeros(size(stim_im,1),size(stim_im,2));
    blank_im = zeros(10,10);
    imwrite(stim_im,'frame2.bmp');
    imwrite(blank_im,'frame3.bmp');

else
    cd([pwd,'\tempStimulus']);
end

blank_im = zeros(10,10);
imwrite(stim_im,'frame2.bmp');
imwrite(blank_im,'frame3.bmp');
imwrite(ir_im,'frame4.bmp');
cd ..;
     
     
         

function startup

dummy=ones(10,10);
if isdir([pwd,'\tempStimulus']) == 0;
    mkdir(pwd,'tempStimulus');
    cd([pwd,'\tempStimulus']);
    
    imwrite(dummy,'frame2.bmp');
%     fid = fopen('frame2.buf','w');
%     fwrite(fid,size(dummy,2),'uint16');
%     fwrite(fid,size(dummy,1),'uint16');
%     fwrite(fid, dummy, 'double');
%     fclose(fid);
else
    cd([pwd,'\tempStimulus']);
    delete ('*.*');
    imwrite(dummy,'frame2.bmp');
%     fid = fopen('frame2.buf','w');
%     fwrite(fid,size(dummy,2),'uint16');
%     fwrite(fid,size(dummy,1),'uint16');
%     fwrite(fid, dummy, 'double');
%     fclose(fid);
end
cd ..;
