function varargout = ColorNamingBasicConfig(varargin)
% COLORNAMINGBASICCONFIG MATLAB code for ColorNamingBasicConfig.fig
%      COLORNAMINGBASICCONFIG, by itself, creates a new COLORNAMINGBASICCONFIG or raises the existing
%      singleton*.
%
%      H = COLORNAMINGBASICCONFIG returns the handle to a new COLORNAMINGBASICCONFIG or the handle to
%      the existing singleton*.
%
%      COLORNAMINGBASICCONFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in COLORNAMINGBASICCONFIG.M with the given input arguments.
%
%      COLORNAMINGBASICCONFIG('Property','Value',...) creates a new COLORNAMINGBASICCONFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ColorNamingBasicConfig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ColorNamingBasicConfig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ColorNamingBasicConfig

% Last Modified by GUIDE v2.5 16-Jan-2013 10:38:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ColorNamingBasicConfig_OpeningFcn, ...
                   'gui_OutputFcn',  @ColorNamingBasicConfig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ColorNamingBasicConfig is made visible.
function ColorNamingBasicConfig_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ColorNamingBasicConfig (see VARARGIN)

% Choose default command line output for ColorNamingBasicConfig

global StimParams VideoParams;
handles.output = hObject;
hAomControl = getappdata(0,'hAomControl');
stimpath = getappdata(hAomControl, 'stimpath');
init_load = 0;
if exist('Experiments\lastBasicCFG.mat','file')==2
    CFG = load('Experiments\lastBasicCFG.mat');
    init_load = 1;
    setappdata(hAomControl, 'CFG', CFG);
end
if (init_load == 0) %load defaults    
    CFG.initials = get(handles.initials, 'String');
    CFG.pupilsize = str2num(get(handles.pupilsize, 'String'));
    CFG.fieldsize = str2num(get(handles.fieldsize, 'String'));
    CFG.presentdur = str2num(get(handles.presentdur, 'String'));
    CFG.trial_dur = str2num(get(handles.trial_dur, 'String'));
    CFG.videodur = str2num(get(handles.videodur, 'String'));
    CFG.autopfx = 1;
    CFG.vidprefix = get(handles.vidprefix, 'String');
    CFG.stimconst = ' ';
    
    % Response mapping
    CFG.ans1 = get(handles.ans1, 'String');
    CFG.ans2 = get(handles.ans2, 'String');
    CFG.ans3 = get(handles.ans3, 'String'); 
    CFG.ans4 = get(handles.ans4, 'String');
    CFG.ans5 = get(handles.ans5, 'String');
    CFG.ans6 = get(handles.ans6, 'String');
    CFG.ans7 = get(handles.ans7, 'String');
    CFG.ans8 = get(handles.ans8, 'String');
    
    CFG.ans1_label = get(handles.ans1_label, 'String');
    CFG.ans2_label = get(handles.ans2_label, 'String');
    CFG.ans3_label = get(handles.ans3_label, 'String'); 
    CFG.ans4_label = get(handles.ans4_label, 'String');
    CFG.ans5_label = get(handles.ans5_label, 'String');
    CFG.ans6_label = get(handles.ans6_label, 'String');
    CFG.ans7_label = get(handles.ans7_label, 'String');
    CFG.ans8_label = get(handles.ans8_label, 'String');
    
    CFG.ntrials = str2num(get(handles.npresent,'String'));
    CFG.gain = 1.0;
    CFG.angle = 0;
    CFG.beep = 1;
    CFG.stimsize  = str2num(get(handles.stim_size_in_pxls, 'String'));
   
    if  ( get(handles.stim_square,'Value')== 1 ) && ( get(handles.stim_circle, 'Value') == 0 ) 
    CFG.stimshape = 'square';
    elseif ( get(handles.stim_square,'Value')== 0 ) && ( get(handles.stim_circle, 'Value') == 1 )
    CFG.stimshape = 'circle';
    end
    
    
    stimpath = getappdata(hAomControl, 'stimpath');
    CFG.stimpath = [pwd,'\tempStimulus\'];
    setappdata(hAomControl, 'CFG', CFG);
end




set(handles.initials, 'String', CFG.initials);
set(handles.pupilsize, 'String', num2str(CFG.pupilsize, '%1.2f'));
set(handles.fieldsize, 'String', num2str(CFG.fieldsize, '%1.2f'));
set(handles.presentdur, 'String', num2str(CFG.presentdur));
set(handles.trial_dur, 'String', num2str(CFG.trial_dur));
set(handles.videodur, 'String', num2str(CFG.videodur));
set(handles.auto_prefix, 'Value', CFG.autopfx);
set(handles.vidprefix, 'String', CFG.vidprefix);
set(handles.kb_StimConst, 'String', CFG.stimconst);


set(handles.ans1, 'String', CFG.ans1);
set(handles.ans2, 'String', CFG.ans2);
set(handles.ans3, 'String', CFG.ans3);
set(handles.ans4, 'String', CFG.ans4);
set(handles.ans5, 'String', CFG.ans5);
set(handles.ans6, 'String', CFG.ans6);
set(handles.ans7, 'String', CFG.ans7);
set(handles.ans8, 'String', CFG.ans8);

set(handles.ans1_label, 'String', CFG.ans1_label);
set(handles.ans2_label, 'String', CFG.ans2_label);
set(handles.ans3_label, 'String', CFG.ans3_label);
set(handles.ans4_label, 'String', CFG.ans4_label);
set(handles.ans5_label, 'String', CFG.ans5_label);
set(handles.ans6_label, 'String', CFG.ans6_label);
set(handles.ans7_label, 'String', CFG.ans7_label);
set(handles.ans8_label, 'String', CFG.ans8_label);




set(handles.npresent, 'String', num2str(CFG.ntrials));
set(handles.gain, 'String', num2str(CFG.gain, '%1.2f'));
set(handles.angle, 'String', num2str(CFG.angle));
set(handles.stim_pres_beep, 'Value', CFG.beep);
set(handles.stimpath, 'String', CFG.stimpath);
set(handles.stim_size_in_pxls, 'String', num2str(CFG.stimsize));
set(handles.vidprefix, 'String', VideoParams.vidprefix);

user_entry = get(handles.initials,'String');
if get(handles.auto_prefix, 'Value') == 1
    set(handles.vidprefix, 'String', user_entry)
elseif get(handles.auto_prefix, 'Value') == 0
    %do nothing
end

% Update handles structure
guidata(hObject, handles);
% load_seq_Callback(hObject, 0, handles);

% UIWAIT makes ColorNamingBasicConfig wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ColorNamingBasicConfig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function presentdur_Callback(hObject, eventdata, handles)
% hObject    handle to presentdur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of presentdur as text
%        str2double(get(hObject,'String')) returns contents of presentdur as a double


% --- Executes during object creation, after setting all properties.
function presentdur_CreateFcn(hObject, eventdata, handles)
% hObject    handle to presentdur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function trial_dur_Callback(hObject, eventdata, handles)
% hObject    handle to trial_dur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trial_dur as text
%        str2double(get(hObject,'String')) returns contents of trial_dur as a double


% --- Executes during object creation, after setting all properties.
function trial_dur_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trial_dur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in load_seq.
% function load_seq_Callback(hObject, eventdata, handles)
% % hObject    handle to load_seq (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% 
% % Hint: get(hObject,'Value') returns toggle state of load_seq
% if get(handles.load_seq, 'Value') == 1
%     %enable load sequence browse button
%     set(handles.browse_seq, 'Enable', 'on');
%     %disable trial number duration, gain, angle, stimbeep fields
%     set(handles.presentdur, 'Enable', 'off');
%     set(handles.trial_dur, 'Enable', 'off');
%     set(handles.npresent, 'Enable', 'off');
%     set(handles.gain, 'Enable', 'off');
%     set(handles.angle, 'Enable', 'off');
%     set(handles.stim_pres_beep, 'Enable', 'off');
% else
%     %disable load sequence browse button
%     set(handles.browse_seq, 'Enable', 'off');
%     %enable trial number duration, gain, angle, stimbeep fields
%     set(handles.presentdur, 'Enable', 'on');
%     set(handles.trial_dur, 'Enable', 'on');
%     set(handles.npresent, 'Enable', 'on');
%     set(handles.gain, 'Enable', 'on');
%     set(handles.angle, 'Enable', 'on');
%     set(handles.stim_pres_beep, 'Enable', 'on');
% end
% 
% 
% % --- Executes on button press in browse_seq.
% function browse_seq_Callback(hObject, eventdata, handles)
% % hObject    handle to browse_seq (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% hAomControl = getappdata(0,'hAomControl');
% CFG = getappdata(hAomControl, 'CFG');
% CFG.seqpath = uigetdir('path','Select directory containing the stimuli');
% setappdata(hAomControl, 'CFG', CFG);


function initials_Callback(hObject, eventdata, handles)
% hObject    handle to initials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of initials as text
%        str2double(get(hObject,'String')) returns contents of initials as a double
user_entry = get(hObject,'string');
if get(handles.auto_prefix, 'Value') == 1
    set(handles.vidprefix, 'String', user_entry)
elseif get(handles.auto_prefix, 'Value') == 0
    %do nothing
end



% --- Executes during object creation, after setting all properties.
function initials_CreateFcn(hObject, eventdata, handles)
% hObject    handle to initials (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pupilsize_Callback(hObject, eventdata, handles)
% hObject    handle to pupilsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pupilsize as text
%        str2double(get(hObject,'String')) returns contents of pupilsize as a double


% --- Executes during object creation, after setting all properties.
function pupilsize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pupilsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fieldsize_Callback(hObject, eventdata, handles)
% hObject    handle to fieldsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fieldsize as text
%        str2double(get(hObject,'String')) returns contents of fieldsize as a double


% --- Executes during object creation, after setting all properties.
function fieldsize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fieldsize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function videodur_Callback(hObject, eventdata, handles)
% hObject    handle to videodur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of videodur as text
%        str2double(get(hObject,'String')) returns contents of videodur as a double


% --- Executes during object creation, after setting all properties.
function videodur_CreateFcn(hObject, eventdata, handles)
% hObject    handle to videodur (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function vidprefix_Callback(hObject, eventdata, handles)
% hObject    handle to vidprefix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of vidprefix as text
%        str2double(get(hObject,'String')) returns contents of vidprefix as a double


% --- Executes during object creation, after setting all properties.
function vidprefix_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vidprefix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in auto_prefix.
function auto_prefix_Callback(hObject, eventdata, handles)
% hObject    handle to auto_prefix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of auto_prefix



function kb_StimConst_Callback(hObject, eventdata, handles)
% hObject    handle to kb_StimConst (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kb_StimConst as text
%        str2double(get(hObject,'String')) returns contents of kb_StimConst as a double


% --- Executes during object creation, after setting all properties.
function kb_StimConst_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kb_StimConst (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans4_Callback(hObject, eventdata, handles)
% hObject    handle to ans4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans4 as text
%        str2double(get(hObject,'String')) returns contents of ans4 as a double


% --- Executes during object creation, after setting all properties.
function ans4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans2_Callback(hObject, eventdata, handles)
% hObject    handle to ans2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans2 as text
%        str2double(get(hObject,'String')) returns contents of ans2 as a double


% --- Executes during object creation, after setting all properties.
function ans2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans1_Callback(hObject, eventdata, handles)
% hObject    handle to ans1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans1 as text
%        str2double(get(hObject,'String')) returns contents of ans1 as a double


% --- Executes during object creation, after setting all properties.
function ans1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans5_Callback(hObject, eventdata, handles)
% hObject    handle to ans5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans5 as text
%        str2double(get(hObject,'String')) returns contents of ans5 as a double


% --- Executes during object creation, after setting all properties.
function ans5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in set_stimpath.
function set_stimpath_Callback(hObject, eventdata, handles)
% hObject    handle to set_stimpath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stimpath = uigetdir('path','Select directory containing the stimuli');
set(handles.stimpath, 'String', [stimpath '\']);


% --- Executes on button press in ok_button.
function ok_button_Callback(hObject, eventdata, handles)
% hObject    handle to ok_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hAomControl = getappdata(0,'hAomControl');
CFG = getappdata(hAomControl, 'CFG');
CFG.ok = 1;
CFG.initials = get(handles.initials, 'String');
CFG.pupilsize = str2num(get(handles.pupilsize, 'String'));
CFG.fieldsize = str2num(get(handles.fieldsize, 'String'));
CFG.presentdur = str2num(get(handles.presentdur, 'String'));
CFG.trial_dur = str2num(get(handles.trial_dur, 'String'));
CFG.ntrials = str2num(get(handles.npresent,'String'));
CFG.gain = str2num(get(handles.gain, 'String'));
CFG.angle = str2num(get(handles.angle, 'String'));
CFG.videodur = str2num(get(handles.videodur, 'String'));
CFG.vidprefix = get(handles.vidprefix, 'String');
CFG.stimconst = get(handles.kb_StimConst, 'String');

CFG.ans1 = get(handles.ans1, 'String');
CFG.ans2 = get(handles.ans2, 'String');
CFG.ans3 = get(handles.ans3, 'String'); 
CFG.ans4 = get(handles.ans4, 'String');
CFG.ans5 = get(handles.ans5, 'String');
CFG.ans6 = get(handles.ans6, 'String');
CFG.ans7 = get(handles.ans7, 'String');
CFG.ans8 = get(handles.ans8, 'String');

CFG.ans1_label = get(handles.ans1_label, 'String');
CFG.ans2_label = get(handles.ans2_label, 'String');
CFG.ans3_label = get(handles.ans3_label, 'String'); 
CFG.ans4_label = get(handles.ans4_label, 'String');
CFG.ans5_label = get(handles.ans5_label, 'String');
CFG.ans6_label = get(handles.ans6_label, 'String');
CFG.ans7_label = get(handles.ans7_label, 'String');
CFG.ans8_label = get(handles.ans8_label, 'String');




CFG.stimsize = str2num(get(handles.stim_size_in_pxls, 'String'));
CFG.record = 1;
CFG.stimpath = [pwd,'\tempStimulus\'];

    if  ( get(handles.stim_square,'Value')== 1 ) && ( get(handles.stim_circle, 'Value') == 0 ) 
    CFG.stimshape = 'square';
    elseif ( get(handles.stim_square,'Value')== 0 ) && ( get(handles.stim_circle, 'Value') == 1 )
    CFG.stimshape = 'circle';
    end
    
CFG.stimpath = get(handles.stimpath,'String');
setappdata(hAomControl, 'CFG', CFG);
save('Experiments\lastBasicCFG.mat', '-struct', 'CFG');
close;


% --- Executes on button press in cancelbutton.
function cancelbutton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hAomControl = getappdata(0,'hAomControl');
CFG = getappdata(hAomControl, 'CFG');
CFG.ok = 0;
setappdata(hAomControl, 'CFG', CFG);
close;


function npresent_Callback(hObject, eventdata, handles)
% hObject    handle to npresent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of npresent as text
%        str2double(get(hObject,'String')) returns contents of npresent as a double


% --- Executes during object creation, after setting all properties.
function npresent_CreateFcn(hObject, eventdata, handles)
% hObject    handle to npresent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gain_Callback(hObject, eventdata, handles)
% hObject    handle to gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gain as text
%        str2double(get(hObject,'String')) returns contents of gain as a double


% --- Executes during object creation, after setting all properties.
function gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function angle_Callback(hObject, eventdata, handles)
% hObject    handle to angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of angle as text
%        str2double(get(hObject,'String')) returns contents of angle as a double


% --- Executes during object creation, after setting all properties.
function angle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to angle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in stim_pres_beep.
function stim_pres_beep_Callback(hObject, eventdata, handles)
% hObject    handle to stim_pres_beep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of stim_pres_beep



function ans3_Callback(hObject, eventdata, handles)
% hObject    handle to ans3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans3 as text
%        str2double(get(hObject,'String')) returns contents of ans3 as a double


% --- Executes during object creation, after setting all properties.
function ans3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function stim_size_in_pxls_Callback(hObject, eventdata, handles)
% hObject    handle to stim_size_in_pxls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of stim_size_in_pxls as text
%        str2double(get(hObject,'String')) returns contents of stim_size_in_pxls as a double


% --- Executes during object creation, after setting all properties.
function stim_size_in_pxls_CreateFcn(hObject, eventdata, handles)
% hObject    handle to stim_size_in_pxls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in stim_circle.
function stim_circle_Callback(hObject, eventdata, handles)
% hObject    handle to stim_circle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.stim_circle,'Value',(get(hObject,'Value')));
set(handles.stim_square,'Value',~(get(hObject,'Value')));
% Hint: get(hObject,'Value') returns toggle state of stim_circle


% --- Executes on button press in stim_square.
function stim_square_Callback(hObject, eventdata, handles)
% hObject    handle to stim_square (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.stim_circle,'Value',~(get(hObject,'Value')));
set(handles.stim_square,'Value',(get(hObject,'Value')));
% Hint: get(hObject,'Value') returns toggle state of stim_square


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function ans6_label_Callback(hObject, eventdata, handles)
% hObject    handle to ans6_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans6_label as text
%        str2double(get(hObject,'String')) returns contents of ans6_label as a double


% --- Executes during object creation, after setting all properties.
function ans6_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans6_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans7_label_Callback(hObject, eventdata, handles)
% hObject    handle to ans7_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans7_label as text
%        str2double(get(hObject,'String')) returns contents of ans7_label as a double


% --- Executes during object creation, after setting all properties.
function ans7_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans7_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans8_label_Callback(hObject, eventdata, handles)
% hObject    handle to ans8_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans8_label as text
%        str2double(get(hObject,'String')) returns contents of ans8_label as a double


% --- Executes during object creation, after setting all properties.
function ans8_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans8_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans6_Callback(hObject, eventdata, handles)
% hObject    handle to ans6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans6 as text
%        str2double(get(hObject,'String')) returns contents of ans6 as a double


% --- Executes during object creation, after setting all properties.
function ans6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans7_Callback(hObject, eventdata, handles)
% hObject    handle to ans7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans7 as text
%        str2double(get(hObject,'String')) returns contents of ans7 as a double


% --- Executes during object creation, after setting all properties.
function ans7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ans8_Callback(hObject, eventdata, handles)
% hObject    handle to ans8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ans8 as text
%        str2double(get(hObject,'String')) returns contents of ans8 as a double


% --- Executes during object creation, after setting all properties.
function ans8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ans8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
